-------------------------------------------------------------------------------
-- File name : basic_components.vhd
-- Title     : Basic Gates
-- project   : ECE 485
-- Library   : multi-cycle processor
-- Author(s) : Ivan Castellanos
-- Purpose   : definition of multi-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
USE ieee.std_logic_1164.ALL;

entity mux21 is
  port (a   : in  std_logic;
        b   : in  std_logic;
        sel : in  std_logic;
        z   : out std_logic);
end mux21;

architecture behv of mux21 is
begin
  z <= (a and not sel) or (b and sel);
end behv;

library ieee;
use ieee.std_logic_1164.all;

entity mux21_5 is
  port (a   : in  std_logic_vector(4 downto 0);
        b   : in  std_logic_vector(4 downto 0);
        sel : in  std_logic;
        z   : out std_logic_vector(4 downto 0));
end mux21_5;

architecture behv of mux21_5 is
begin
  z( 0) <= (a( 0) and not sel) or (b( 0) and sel);
  z( 1) <= (a( 1) and not sel) or (b( 1) and sel);
  z( 2) <= (a( 2) and not sel) or (b( 2) and sel);
  z( 3) <= (a( 3) and not sel) or (b( 3) and sel);
  z( 4) <= (a( 4) and not sel) or (b( 4) and sel);  
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux21_6 is
  port (a   : in  std_logic_vector(5 downto 0);
        b   : in  std_logic_vector(5 downto 0);
        sel : in  std_logic;
        z   : out std_logic_vector(5 downto 0));
end mux21_6;

architecture behv of mux21_6 is
begin
  z( 0) <= (a( 0) and not sel) or (b( 0) and sel);
  z( 1) <= (a( 1) and not sel) or (b( 1) and sel);
  z( 2) <= (a( 2) and not sel) or (b( 2) and sel);
  z( 3) <= (a( 3) and not sel) or (b( 3) and sel);
  z( 4) <= (a( 4) and not sel) or (b( 4) and sel);
  z( 5) <= (a( 5) and not sel) or (b( 5) and sel);  
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux21_9 is
  port (a   : in  std_logic_vector(8 downto 0);
        b   : in  std_logic_vector(8 downto 0);
        sel : in  std_logic;
        z   : out std_logic_vector(8 downto 0));
end mux21_9;

architecture behv of mux21_9 is
begin
  z( 0) <= (a( 0) and not sel) or (b( 0) and sel);
  z( 1) <= (a( 1) and not sel) or (b( 1) and sel);
  z( 2) <= (a( 2) and not sel) or (b( 2) and sel);
  z( 3) <= (a( 3) and not sel) or (b( 3) and sel);
  z( 4) <= (a( 4) and not sel) or (b( 4) and sel);
  z( 5) <= (a( 5) and not sel) or (b( 5) and sel);
  z( 6) <= (a( 6) and not sel) or (b( 6) and sel);
  z( 7) <= (a( 7) and not sel) or (b( 7) and sel);
  z( 8) <= (a( 8) and not sel) or (b( 8) and sel);
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux21_32 is
  port (a   : in  std_logic_vector(31 downto 0);
        b   : in  std_logic_vector(31 downto 0);
        sel : in  std_logic;
        z   : out std_logic_vector(31 downto 0));
end mux21_32;

architecture behv of mux21_32 is
begin
  z( 0) <= (a( 0) and not sel) or (b( 0) and sel);
  z( 1) <= (a( 1) and not sel) or (b( 1) and sel);
  z( 2) <= (a( 2) and not sel) or (b( 2) and sel);
  z( 3) <= (a( 3) and not sel) or (b( 3) and sel);
  z( 4) <= (a( 4) and not sel) or (b( 4) and sel);
  z( 5) <= (a( 5) and not sel) or (b( 5) and sel);
  z( 6) <= (a( 6) and not sel) or (b( 6) and sel);
  z( 7) <= (a( 7) and not sel) or (b( 7) and sel);
  z( 8) <= (a( 8) and not sel) or (b( 8) and sel);
  z( 9) <= (a( 9) and not sel) or (b( 9) and sel);
  z(10) <= (a(10) and not sel) or (b(10) and sel);
  z(11) <= (a(11) and not sel) or (b(11) and sel);
  z(12) <= (a(12) and not sel) or (b(12) and sel);
  z(13) <= (a(13) and not sel) or (b(13) and sel);
  z(14) <= (a(14) and not sel) or (b(14) and sel);
  z(15) <= (a(15) and not sel) or (b(15) and sel);
  z(16) <= (a(16) and not sel) or (b(16) and sel);
  z(17) <= (a(17) and not sel) or (b(17) and sel);
  z(18) <= (a(18) and not sel) or (b(18) and sel);
  z(19) <= (a(19) and not sel) or (b(19) and sel);
  z(20) <= (a(20) and not sel) or (b(20) and sel);
  z(21) <= (a(21) and not sel) or (b(21) and sel);
  z(22) <= (a(22) and not sel) or (b(22) and sel);
  z(23) <= (a(23) and not sel) or (b(23) and sel);
  z(24) <= (a(24) and not sel) or (b(24) and sel);
  z(25) <= (a(25) and not sel) or (b(25) and sel);
  z(26) <= (a(26) and not sel) or (b(26) and sel);
  z(27) <= (a(27) and not sel) or (b(27) and sel);
  z(28) <= (a(28) and not sel) or (b(28) and sel);
  z(29) <= (a(29) and not sel) or (b(29) and sel);
  z(30) <= (a(30) and not sel) or (b(30) and sel);
  z(31) <= (a(31) and not sel) or (b(31) and sel);
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux41 is
  port (a   : in  std_logic;
        b   : in  std_logic;
        c   : in  std_logic;
        d   : in  std_logic;
        sel : in  std_logic_vector(1 downto 0);
        z   : out std_logic);
end mux41;

architecture behv of mux41 is
begin
  with sel select
    z <= a when "00",
    b when "01",
    c when "10",
    d when others;
end behv;

library ieee;
use ieee.std_logic_1164.all;

entity mux41_5 is
  port (a   : in  std_logic_vector(4 downto 0);
        b   : in  std_logic_vector(4 downto 0);
        c   : in  std_logic_vector(4 downto 0);
        sel : in  std_logic_vector(1 downto 0);
        z   : out std_logic_vector(4 downto 0));
end mux41_5;

architecture behv of mux41_5 is
begin
  with sel select
    z <= a when "00",
    b when "01",
    c when others;
end behv;

library ieee;
use ieee.std_logic_1164.all;

entity mux41_6 is
  port (a   : in  std_logic_vector(5 downto 0);
        b   : in  std_logic_vector(5 downto 0);
        c   : in  std_logic_vector(5 downto 0);
        d   : in  std_logic_vector(5 downto 0);       
        sel : in  std_logic_vector(1 downto 0);
        z   : out std_logic_vector(5 downto 0));  
end mux41_6;

architecture behv of mux41_6 is
begin
  with sel select
    z <= a when "00",
    b when "01",
    c when "10",
    d when others;
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux41_9 is
  port (a   : in  std_logic_vector(8 downto 0);
        b   : in  std_logic_vector(8 downto 0);
        c   : in  std_logic_vector(8 downto 0);
        d   : in  std_logic_vector(8 downto 0);       
        sel : in  std_logic_vector(1 downto 0);
        z   : out std_logic_vector(8 downto 0));
end mux41_9;

architecture behv of mux41_9 is
begin
  with sel select
    z <= a when "00",
    b when "01",
    c when "10",
    d when others;
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity mux41_32 is
  port (a   : in  std_logic_vector(31 downto 0);
        b   : in  std_logic_vector(31 downto 0);
        c   : in  std_logic_vector(31 downto 0);
        d   : in  std_logic_vector(31 downto 0);       
        sel : in  std_logic_vector(1 downto 0);
        z   : out std_logic_vector(31 downto 0));  
end mux41_32;

architecture behv of mux41_32 is
begin
  with sel select
    z <= a when "00",
    b when "01",
    c when "10",
    d when others;
end behv;


library ieee;
use ieee.std_logic_1164.all;

entity dflipflop is
  port (d   : in  std_logic;
        clk : in  std_logic;
        q   : out std_logic);
end dflipflop;

architecture behavior of dflipflop is
begin
  process (clk)
  begin
    if (clk'event and clk = '1') then
      q <= d;
    end if;
  end process;
end behavior;


library ieee;
use ieee.std_logic_1164.all;

entity register6 is
  port (d   : in  std_logic_vector (5 downto 0);
        clk : in  std_logic;
        q   : out std_logic_vector (5 downto 0));
end register6;

architecture behavior of register6 is
begin
  process (clk)
  begin
    if (clk'event and clk = '1') then
      q <= d;
    end if;
  end process;
end behavior;


library ieee;
use ieee.std_logic_1164.all;

entity register9 is
  port (d   : in  std_logic_vector (8 downto 0);
        clk : in  std_logic;
        q   : out std_logic_vector (8 downto 0));
end register9;

architecture behavior of register9 is
begin
  process (clk)
  begin
    if (clk'event and clk = '1') then
      q <= d;
    end if;
  end process;
end behavior;


library ieee;
use ieee.std_logic_1164.all;

entity register32 is
  port (d   : in  std_logic_vector(31 downto 0);
        clk : in  std_logic;
        q   : out std_logic_vector(31 downto 0));
end register32;

architecture behavior of register32 is
begin
  process (clk)
  begin
    if (clk'event and clk = '1') then
      q <= d;
    end if;
  end process; 
end behavior;

