-------------------------------------------------------------------------------
-- File name : fulladder.vhdl
-- Title     : 9 gate Full Adder
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity fulladder is
    port (A    : in  std_logic;
          B    : in  std_logic;
          Cin  : in  std_logic;
          Sum  : out std_logic;
          Cout : out std_logic);
end fulladder;

architecture structure of fulladder is

  signal w1, w2, w3, w4 : std_logic;
  
begin
    w1   <= A and B;
    w2   <= (A or B) and not w1;
    w3   <= w2 and Cin;
    Sum  <= (w2 or Cin) and not w3;
    Cout <= w1 or w3;    
end structure;

