||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||                                                            || 
|| ECE 429 Final Project                                      ||
|| Modified Newton Raphson Divison                            ||
||                                                            || 
|| Irsim Test suite                                           ||
||                                                            ||
|| Automatically runs 44 test vectors                         ||
|| Assumes the following opcodes: LOAD=0100                   ||
||                                 DIV=0101                   ||
|| (do a global replace if you have a different encoding)     ||
||                                                            ||
|| Use like this:                                             ||
|| irsim scmos.prm project.sim -project.cmd | grep "failed"   ||
|| (only failing vectors will be displayed)                   ||
||                                                            || 
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

||
|| Global setups
||
stepsize 50
clock clk 0 1 

||
|| Vector definitions (modify to personal needs)
|| (note how I abuse "error" to emulate a 4 bit wide opcode vector)
||
vector in in[7] in[6] in[5] in[4] in[3] in[2] in[1] in[0]
vector acc acc[7] acc[6] acc[5] acc[4] acc[3] acc[2] acc[1] acc[0]
vector opcode error opcode[2] opcode[1] opcode[0]

|| 
|| ana command not needed for automated checking
||
|| ana reset error acc_load s1 s2 s3 s4 clk opcode in acc

|| 
|| Reset sequence (modify to personal needs)
||
h reset
set in 00000000
set opcode 0000
c
l reset

|| 1.000000
|| 1.984375
||
|| Answer 0.5 = 0.100000
set opcode 0100
set in 01000000
c
set opcode 0101
set in 01111111
c
c
c
c
c
c
c
c
c
assert acc 00100000
||-----------------------------------------

|| 1.328125
|| 1.750000
||
|| Answer 0.765625 = 00.110001
set opcode 0100
set in 01010101
c
set opcode 0101
set in 01110000
c
c
c
c
c
c
c
c
c
assert acc 00110000

|| 1.484375
|| 1.000000
||
set opcode 0100
set in 01011111
c
set opcode 0101
set in 01000000
c
c
c
c
c
c
c
c
c
assert acc 01011111
||-----------------------------------------

|| 1.984375
|| 1.328125
||
set opcode 0100
set in 01111111
c
set opcode 0101
set in 01010101
c
c
c
c
c
c
c
c
c
assert acc 01011111
||-----------------------------------------

|| 1.015625
|| 1.000000
||
set opcode 0100
set in 01000001
c
set opcode 0101
set in 01000000
c
c
c
c
c
c
c
c
c
|| Answer 1.015625 = 1.000001
||-----------------------------------------


|| 1.000000
|| 1.015625
||
set opcode 0100
set in 01000000
c
set opcode 0101
set in 01000001
c
c
c
c
c
c
c
c
c
assert acc 00111111
||-----------------------------------------


|| 1.59375
|| 1.03125
||
set opcode 0100
set in 01100110
c
set opcode 0101
set in 01000010
c
c
c
c
c
c
c
c
c
assert acc 01100011
||-----------------------------------------


|| 1.890625
|| 1.59375
||
set opcode 0100
set in 01111001
c
set opcode 0101
set in 01100110
c
c
c
c
c
c
c
c
c
assert acc 01001100
||-----------------------------------------


|| 1.984375
|| 1.296875
set opcode 0100
set in 01111111
c
set opcode 0101
set in 01010011
c
c
c
c
c
c
c
c
c
assert acc 01100001
||-----------------------------------------


|| 1.015625
|| 1.078125
set opcode 0100
set in 01000001
c
set opcode 0101
set in 01000101
c
c
c
c
c
c
c
c
c
assert acc 00111101
||-----------------------------------------


|| 1.046875
|| 1.75
||
set opcode 0100
set in 01000011
c
set opcode 0101
set in 01110000
c
c
c
c
c
c
c
c
c
assert acc 00100110

|| Divisior is now negative
|| +1.000000
|| -1.984375
||
|| Answer -0.5 = 11.100000
set opcode 0100
set in 01000000
c
set opcode 0101
set in 10000001
c
c
c
c
c
c
c
c
c
assert acc 11100000
||-----------------------------------

|| +1.328125
|| -1.750000
||
|| Answer -0.765625 = 11.001111
set opcode 0100
set in 01010101
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 11010000
||-----------------------------------


|| +1.484375
|| -1.000000
||
|| Answer -1.484375 = 10.100001
set opcode 0100
set in 01011111
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 10100001
||-----------------------------------


|| +1.984375
|| -1.328125
||
|| Answer -1.484375 = 10.100001
set opcode 0100
set in 01111111
c
set opcode 0101
set in 10101011
c
c
c
c
c
c
c
c
c
assert acc 10100001
||-----------------------------------


|| +1.015625
|| -1.000000
||
|| Answer -1.015625 = 10.111111
set opcode 0100
set in 01000001
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 10111111
||-----------------------------------


|| +1.000000
|| -1.015625
||
|| Answer -0.984375 = 10.111111
set opcode 0100
set in 01000000
c
set opcode 0101
set in 10111111
c
c
c
c
c
c
c
c
c
assert acc 11000001
||-----------------------------------


|| +1.59375
|| -1.03125
||
|| Answer -1.546875 = 10.011101
set opcode 0100
set in 01100110
c
set opcode 0101
set in 10111110
c
c
c
c
c
c
c
c
c
assert acc 10011101
||-----------------------------------


|| +1.890625
|| -1.59375
||
|| Answer -1.1875 = 10.110100
set opcode 0100
set in 01111001
c
set opcode 0101
set in 10011010
c
c
c
c
c
c
c
c
c
assert acc 10110100
||-----------------------------------


|| +1.984375
|| -1.296875
|| Answer -1.515625 = 10.011111
set opcode 0100
set in 01111111
c
set opcode 0101
set in 10101101
c
c
c
c
c
c
c
c
c
assert acc 10011111
||-----------------------------------


|| +1.015625
|| -1.078125
|| Answer -0.9375 = 11.000100
set opcode 0100
set in 01000001
c
set opcode 0101
set in 10111011
c
c
c
c
c
c
c
c
c
assert acc 11000011
||-----------------------------------


|| +1.046875
|| -1.75
||
|| Answer -0.609375 = 11.011001
set opcode 0100
set in 01000011
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 11011010

|| Divisior is now negative
|| +1.000000
|| -1.984375
||
|| Answer -0.5 = 11.100000
set opcode 0100
set in 01000000
c
set opcode 0101
set in 10000001
c
c
c
c
c
c
c
c
c
assert acc 11100000
||-----------------------------------

|| +1.328125
|| -1.750000
||
|| Answer -0.765625 = 11.001111
set opcode 0100
set in 01010101
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 11010000
||-----------------------------------


|| +1.484375
|| -1.000000
||
|| Answer -1.484375 = 10.100001
set opcode 0100
set in 01011111
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 10100001
||-----------------------------------


|| +1.984375
|| -1.328125
||
|| Answer -1.484375 = 10.100001
set opcode 0100
set in 01111111
c
set opcode 0101
set in 10101011
c
c
c
c
c
c
c
c
c
assert acc 10100001
||-----------------------------------


|| +1.015625
|| -1.000000
||
|| Answer -1.015625 = 10.111111
set opcode 0100
set in 01000001
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 10111111
||-----------------------------------


|| +1.000000
|| -1.015625
||
|| Answer -0.984375 = 10.111111
set opcode 0100
set in 01000000
c
set opcode 0101
set in 10111111
c
c
c
c
c
c
c
c
c
assert acc 11000001
||-----------------------------------


|| +1.59375
|| -1.03125
||
|| Answer -1.546875 = 10.011101
set opcode 0100
set in 01100110
c
set opcode 0101
set in 10111110
c
c
c
c
c
c
c
c
c
assert acc 10011101
||-----------------------------------


|| +1.890625
|| -1.59375
||
|| Answer -1.1875 = 10.110100
set opcode 0100
set in 01111001
c
set opcode 0101
set in 10011010
c
c
c
c
c
c
c
c
c
assert acc 10110100
||-----------------------------------


|| +1.984375
|| -1.296875
|| Answer -1.515625 = 10.011111
set opcode 0100
set in 01111111
c
set opcode 0101
set in 10101101
c
c
c
c
c
c
c
c
c
assert acc 10011111
||-----------------------------------


|| +1.015625
|| -1.078125
|| Answer -0.9375 = 11.000100
set opcode 0100
set in 01000001
c
set opcode 0101
set in 10111011
c
c
c
c
c
c
c
c
c
assert acc 11000011
||-----------------------------------


|| +1.046875
|| -1.75
||
|| Answer -0.609375 = 11.011001
set opcode 0100
set in 01000011
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 11011010


|| Divisior and Dividend are now negative
|| -1.000000
|| -1.984375
||
|| Answer +0.5 = 00.100000
set opcode 0100
set in 11000000
c
set opcode 0101
set in 10000001
c
c
c
c
c
c
c
c
c
assert acc 00100000
||-----------------------------------------


|| -1.328125
|| -1.750000
||
|| Answer +0.765625 = 00.110001
set opcode 0100
set in 10101011
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 00110000
||-----------------------------------------


|| -1.484375
|| -1.000000
||
|| Answer +1.484375 = 01.011111
set opcode 0100
set in 10100001
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 01011111
||-----------------------------------------


|| -1.984375
|| -1.328125
||
|| Answer +1.484375 = 01.011111
set opcode 0100
set in 10000001
c
set opcode 0101
set in 10101011
c
c
c
c
c
c
c
c
c
assert acc 01011111
||-----------------------------------------


|| -1.015625
|| -1.000000
||
|| Answer +1.015625 = 01.000001
set opcode 0100
set in 10111111
c
set opcode 0101
set in 11000000
c
c
c
c
c
c
c
c
c
assert acc 01000001
||-----------------------------------------


|| -1.000000
|| -1.015625
||
|| Answer +0.984375 = 00.111111
set opcode 0100
set in 11000000
c
set opcode 0101
set in 10111111
c
c
c
c
c
c
c
c
c
assert acc 00111111
||-----------------------------------------


|| -1.59375
|| -1.03125
||
|| Answer +1.546875 = 01.100011
set opcode 0100
set in 10011001
c
set opcode 0101
set in 10111110
c
c
c
c
c
c
c
c
c
assert acc 01100100
||-----------------------------------------


|| -1.890625
|| -1.59375
||
|| Answer +1.1875 = 01.001100
set opcode 0100
set in 10000111
c
set opcode 0101
set in 10011010
c
c
c
c
c
c
c
c
c
assert acc 01001100
||-----------------------------------------


|| -1.984375
|| -1.296875
|| Answer +1.515625 = 01.100001
set opcode 0100
set in 10000001
c
set opcode 0101
set in 10101101
c
c
c
c
c
c
c
c
c
assert acc 01100001
||-----------------------------------------


|| -1.015625
|| -1.078125
|| Answer +0.9375 = 00.111100
set opcode 0100
set in 10111111
c
set opcode 0101
set in 10111011
c
c
c
c
c
c
c
c
c
assert acc 00111101
||-----------------------------------------


|| -1.046875
|| -1.75
||
|| Answer +0.609375 = 00.100111
set opcode 0100
set in 10111101
c
set opcode 0101
set in 10010000
c
c
c
c
c
c
c
c
c
assert acc 00100110


exit
