-------------------------------------------------------------------------------
-- File name : mux21x9.vhdl
-- Title     : 2-1 x 9-bit Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux21x9 is
  port (A : in  std_logic_vector(8 downto 0);
        B : in  std_logic_vector(8 downto 0);
        S : in  std_logic;
        Y : out std_logic_vector(8 downto 0));
end mux21x9;

architecture structure of mux21x9 is

  component mux21 
    port (D0 : in  std_logic;
          D1 : in  std_logic;
          S0 : in  std_logic;
          Y  : out std_logic);
  end component;
  
begin

  mux1  : mux21 port map (A(0), B(0), S, Y(0));
  mux2  : mux21 port map (A(1), B(1), S, Y(1));
  mux3  : mux21 port map (A(2), B(2), S, Y(2));
  mux4  : mux21 port map (A(3), B(3), S, Y(3));
  mux5  : mux21 port map (A(4), B(4), S, Y(4));
  mux6  : mux21 port map (A(5), B(5), S, Y(5));
  mux7  : mux21 port map (A(6), B(6), S, Y(6));
  mux8  : mux21 port map (A(7), B(7), S, Y(7));
  mux9  : mux21 port map (A(8), B(8), S, Y(8));

end structure;
