-------------------------------------------------------------------------------
-- File name : rca9.vhdl
-- Title     : 9-bit RCA CPA
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity rca9 is
  port(A : in std_logic_vector(8 downto 0);
       B : in std_logic_vector(8 downto 0);
       R : out std_logic_vector(8 downto 0));
end rca9;

architecture structure of rca9 is

  component fulladder 
    port (A    : in  std_logic;
          B    : in  std_logic;
          Cin  : in  std_logic;
          Sum  : out std_logic;
          Cout : out std_logic);
  end component;

  signal c_out : std_logic_vector(7 downto 0);

begin
	
  fa0  : fulladder port map(A(0), B(0), '0', R(0), c_out(0));  
  fa1  : fulladder port map(A(1), B(1), c_out(0), R(1), c_out(1));
  fa2  : fulladder port map(A(2), B(2), c_out(1), R(2), c_out(2));
  fa3  : fulladder port map(A(3), B(3), c_out(2), R(3), c_out(3));
  fa4  : fulladder port map(A(4), B(4), c_out(3), R(4), c_out(4));
  fa5  : fulladder port map(A(5), B(5), c_out(4), R(5), c_out(5));
  fa6  : fulladder port map(A(6), B(6), c_out(5), R(6), c_out(6));
  fa7  : fulladder port map(A(7), B(7), c_out(6), R(7), c_out(7));
  fa8  : fulladder port map(A(8), B(8), c_out(7), R(8));
  
end structure;
